bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: base64 tool?


From: Simon Josefsson
Subject: Re: base64 tool?
Date: Mon, 27 Feb 2006 14:33:44 +0100
User-agent: Gnus/5.110004 (No Gnus v0.4) Emacs/22.0.50 (gnu/linux)

Jim Meyering <address@hidden> writes:

>>> Would you please write a test script to go along with that?
>>> I'd prefer that you model the new file, say tests/misc/base64,
>>> after one of the existing ones that uses the Coreutils.pm module.
>>> For example, tests/misc/expand is nice and small.
>>
>> I forgot to include it, it was part of the first patch.  Is the below
>> sufficient?
>
> It'd be nice if you would add examples demonstrating
> use of the options.  For example, I tried this:
>
>   $ seq 100|./base64 --wr=0
>   ./base64: invalid wrap size: 0
>   [Exit 1]
>
> A basic test might have caught that.

Here are updated tests.  They test several corner cases, but still not
comprehensive.

Index: tests/base64/Makefile.am
===================================================================
RCS file: tests/base64/Makefile.am
diff -N tests/base64/Makefile.am
--- /dev/null   1 Jan 1970 00:00:00 -0000
+++ tests/base64/Makefile.am    27 Feb 2006 13:33:05 -0000
@@ -0,0 +1,12 @@
+## Process this file with automake to produce Makefile.in -*-Makefile-*-.
+
+EXTRA_DIST = $(TESTS)
+
+TESTS_ENVIRONMENT = \
+  top_srcdir=$(top_srcdir) \
+  srcdir=$(srcdir) \
+  PERL="$(PERL)" \
+  PATH="`pwd`/../../src$(PATH_SEPARATOR)$$PATH" \
+  PROG=base64
+
+TESTS = basic-1
Index: tests/base64/basic-1
===================================================================
RCS file: tests/base64/basic-1
diff -N tests/base64/basic-1
--- /dev/null   1 Jan 1970 00:00:00 -0000
+++ tests/base64/basic-1        27 Feb 2006 13:33:05 -0000
@@ -0,0 +1,51 @@
+#!/bin/sh
+# -*- perl -*-
+# Exercise base64.
+
+: ${PERL=perl}
+: ${srcdir=.}
+
+$PERL -e 1 > /dev/null 2>&1 || {
+  echo 1>&2 "$0: configure didn't find a usable version of Perl," \
+    "so can't run this test"
+  exit 77
+}
+
+exec $PERL -w -I$srcdir/.. -MCoreutils -- - <<\EOF
+require 5.003;
+use strict;
+
+(my $program_name = $0) =~ s|.*/||;
+
+# Turn off localisation of executable's ouput.
address@hidden(LANGUAGE LANG LC_ALL)} = ('C') x 3;
+
+my $degenerate = "d41d8cd98f00b204e9800998ecf8427e";
+
+my @Tests =
+    (
+     ['empty', {IN=>''}, {OUT=>""}],
+     ['inout', {IN=>'a'}, {OUT=>"YQ==\n"}],
+     ['wrap', '--wrap 0', {IN=>'foo'}, {OUT=>'Zm9v'}],
+     ['wrap5-39', '--wrap 5', {IN=>'a' x 39}, 
{OUT=>"YWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFh\n"}],
+     ['wrap5-40', '--wrap 5', {IN=>'a' x 40}, 
{OUT=>"YWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYQ=\n=\n"}],
+     ['wrap5-41', '--wrap 5', {IN=>'a' x 41}, 
{OUT=>"YWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWE\n=\n"}],
+     ['wrap5-42', '--wrap 5', {IN=>'a' x 42}, 
{OUT=>"YWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nh\n"}],
+     ['wrap5-43', '--wrap 5', {IN=>'a' x 43}, 
{OUT=>"YWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nhYQ==\n"}],
+     ['wrap5-44', '--wrap 5', {IN=>'a' x 44}, 
{OUT=>"YWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nhYWE=\n"}],
+     ['wrap5-45', '--wrap 5', {IN=>'a' x 45}, 
{OUT=>"YWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nhYWFh\n"}],
+     ['wrap5-46', '--wrap 5', {IN=>'a' x 46}, 
{OUT=>"YWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nhYWFh\nYWFhY\nWFhYW\nFhYWF\nhYWFh\nYQ==\n"}],
+     ['baddecode', '--decode', {IN=>'a'}, {OUT=>""}, {ERR_SUBST => 's/.*: 
invalid input//'}, {ERR => "\n"}, {EXIT => 1}],
+     ['baddecode2', '--decode', {IN=>'ab'}, {OUT=>"i"}, {ERR_SUBST => 's/.*: 
invalid input//'}, {ERR => "\n"}, {EXIT => 1}],
+     ['baddecode3', '--decode', {IN=>'Zzz'}, {OUT=>"g<"}, {ERR_SUBST => 's/.*: 
invalid input//'}, {ERR => "\n"}, {EXIT => 1}],
+     ['baddecode4', '--decode', {IN=>'Zz='}, {OUT=>"g"}, {ERR_SUBST => 's/.*: 
invalid input//'}, {ERR => "\n"}, {EXIT => 1}],
+     ['baddecode5', '--decode', {IN=>'Z==='}, {OUT=>""}, {ERR_SUBST => 's/.*: 
invalid input//'}, {ERR => "\n"}, {EXIT => 1}]
+    );
+
+my $save_temps = $ENV{DEBUG};
+my $verbose = $ENV{VERBOSE};
+
+my $prog = $ENV{PROG} || die "$0: \$PROG not specified in environment\n";
+my $fail = run_tests ($program_name, $prog, address@hidden, $save_temps, 
$verbose);
+exit $fail;
+EOF




reply via email to

[Prev in Thread] Current Thread [Next in Thread]